# numynal

A comprehensive data analysis library

## Modules

- Data preprocessing

  - Missing data
  - Data normalisation and scaling
  - Data augmentation and feature engineering
  - Outlier detection and handling
  - Data imputation

- EDA

  - Statistical summary
  - Correlation and Covariance analysis
  - Interactive web dashboards

- Statstical analysis

  - Distribution
  - Statistical model building
  - Confidence intervals and bootstrap
  - Hypothesis testing
  - Bayesian Methods

- Time Series analysis

  - Decomposition
  - Forecasting methods
  - Anomoly detection

- Autograd

  - Building up on pyAutoGrad
  - Custom optimisation models
  - Autodiff graph visualisation

- ML Models

  - Supervised learning
  - Unsupervised learning
  - Ensemble methods
  - Hyperparameter tuning and model evaluation
  - Model pipelines
  - Transfer learning

- Deep learning

  - NN modules
  - Graph NN
  - Quantisation and pruning
  - pretrained models for common tasks
  - custom architecture support
  - optimisation techniques

- Visualisation

  - Traditional visualisation
  - Model performance visualisation

- Optimisation

  - Parallel processing and GPU support
  - AutoML
  - Model explainability and interpretability support
  - Workflow automation
  - Distributed training

- Performance Monitoring

  - Metrics tracking
  - Real-time monitoring for deployed model
  - Feedback loop

- API support to databases
  - SQL databases (postgres, sqlite, mysql)
  - MongoDB
  - Data streaming support
